/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */

#include "config.h"
#include	<sys/types.h>
#include	<sys/timeb.h>
#include	<X11/StringDefs.h>
#include	<X11/Intrinsic.h>
#include	<X11/IntrinsicP.h>
#define NEED_REPLIES
#include	<X11/Xlibint.h>
#include "debug.h"

#define COLOR_FACTOR       3
#define BRIGHTNESS_FACTOR  1

Status myXAllocColor(register Display * dpy, Colormap cmap, XColor * xcolor)
{
    Status retstat;

    if (!(retstat = XAllocColor(dpy, cmap, xcolor))) {
	XColor *cols;
	unsigned int ncols, i, closepix;
	long int closediff;

	ncols = 1 << DefaultDepth(dpy, DefaultScreen(dpy));

	cols = (XColor *) calloc(ncols, sizeof(XColor));
	for (i = 0; i < ncols; ++i)
	    cols[i].pixel = i;
	XQueryColors(dpy, cmap, cols, ncols);

	do {
	    for (i = 0, closediff = 0x7FFFFFFF; i < ncols; ++i) {

		long int newclosediff =
		COLOR_FACTOR * (
			   abs((long) xcolor->red - (long) cols[i].red) +
		       abs((long) xcolor->green - (long) cols[i].green) +
			abs((long) xcolor->blue - (long) cols[i].blue)) +
		BRIGHTNESS_FACTOR * abs(((long) xcolor->red + (long) xcolor->green + (long) xcolor->blue) - ((long) cols[i].red + (long) cols[i].green + (long) cols[i].blue));

		if (newclosediff < closediff) {
		    closepix = i;
		    closediff = newclosediff;
		}
	    }

	    xcolor->red = cols[closepix].red;
	    xcolor->green = cols[closepix].green;
	    xcolor->blue = cols[closepix].blue;
	    /*
	       ** Now paint it black so we don't loop
	       ** in the case that this colour is read-write.
	     */
	    cols[closepix].red = 0;
	    cols[closepix].green = 0;
	    cols[closepix].blue = 0;
	    retstat = XAllocColor(dpy, cmap, xcolor);
	} while (retstat == 0);
	free(cols);
    }
    return (retstat);
}

