/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */

#include "config.h"

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>

#include "xmap.h"
#include "mode.h"
#include "debug.h"

static struct sigaction sa_fpe;
static struct sigaction sa_pipe;

static void fpe_handler( int what )
{
    fprintf(stderr,"Caught SIGFPE with arg=%d\n",what);
}

static void pipe_handler( int what )
{
    fprintf(stderr,"Caught SIGPIPE with arg=%d\n",what);
}

void install_sig_handlers()
{
    sigset_t set;

#if 0
    sigemptyset(&set);
    sa_fpe.sa_handler = fpe_handler;
    sa_fpe.sa_mask = set;
    sa_fpe.sa_flags = SA_RESTART;

    if (sigaction(SIGFPE, &sa_fpe, NULL) == -1)
	error("Could not set handler\nfor SIGFPE.\n", error);
#endif
    sigemptyset(&set);
    sa_pipe.sa_handler = pipe_handler;
    sa_pipe.sa_mask = set;
    sa_pipe.sa_flags = SA_RESTART;

    if (sigaction(SIGPIPE, &sa_pipe, NULL) == -1)
	error("Could not set handler\nfor SIGPIPE.\n", errno);
}

